From eb04c21373e2a2885f3d52ff192b0499afe3c672 Mon Sep 17 00:00:00 2001
From: Adhemerval Zanella <adhemerval.zanella@linaro.org>
Date: Wed, 20 Dec 2017 09:47:44 -0200
Subject: [PATCH] posix: Sync gnulib regex implementation

This patch syncs the regex implementation with gnulib (commit 0ee5212).
Only two changes in GLIBC regex testing are required:

  1. posix/bug-regex28.c: as previously discussed [1] the change of
     expected results on the pattern should be safe.

  2. posix/PCRE.tests: the ERE (a)|\1 is malformed (in the sense that
     the \1 doesn't mean anything) and although current GLIBC accepts
     it has undefined behavior.  This patch removes the specific test.

This sync contains some patches from thread 'Regex: Make libc regex
more usable outside GLIBC.' [2] which have been pushed upstream in
gnulib.  This patches also fixes some regex issues (BZ #23233,
BZ #21163, BZ #18986, BZ #13762) and I did not add testcases for
both #23233 and #13762 because I couldn't think a simple way to
trigger the expected failure path to trigger them.

Checked on x86_64-linux-gnu and i686-linux-gnu.

	[BZ #23233]
	[BZ #21163]
	[BZ #18986]
	[BZ #13762]
	* posix/Makefile (tests): Add bug-regex37 and bug-regex38.
	* posix/PCRE.tests: Remove invalid test.
	* posix/bug-regex28.c: Fix expected values for used syntax.
	* posix/bug-regex37.c: New file.
	* posix/bug-regex38.c: Likewise.
	* posix/regcomp.c: Sync with gnulib.
	* posix/regex.c: Likewise.
	* posix/regex.h: Likewise.
	* posix/regex_internal.c: Likewise.
	* posix/regex_internal.h: Likewise.
	* posix/regexec.c: Likewise.

[1] https://sourceware.org/ml/libc-alpha/2017-12/msg00807.html
[2] https://sourceware.org/ml/libc-alpha/2017-12/msg00237.html
---
 ChangeLog              |  18 +
 posix/Makefile         |   3 +-
 posix/PCRE.tests       |  13 -
 posix/bug-regex28.c    |  46 +-
 posix/bug-regex37.c    |  32 ++
 posix/bug-regex38.c    |  32 ++
 posix/regcomp.c        | 597 +++++++++++++++-----------
 posix/regex.c          |  21 +-
 posix/regex.h          | 335 +++++++++------
 posix/regex_internal.c | 295 +++++++------
 posix/regex_internal.h | 442 ++++++++++++-------
 posix/regexec.c        | 936 +++++++++++++++++++++--------------------
 12 files changed, 1609 insertions(+), 1161 deletions(-)
 create mode 100644 posix/bug-regex37.c
 create mode 100644 posix/bug-regex38.c

Index: glibc-2.11.3/posix/PCRE.tests
===================================================================
--- glibc-2.11.3.orig/posix/PCRE.tests
+++ glibc-2.11.3/posix/PCRE.tests
@@ -1774,19 +1774,6 @@ No match
  0: abcabc
  1: abc
 
-/(a)|\1/
-    a
- 0: a
- 1: a
-    *** Failers
- 0: a
- 1: a
-    ab
- 0: a
- 1: a
-    x
-No match
-
 /abc/i
     ABC
  0: ABC
Index: glibc-2.11.3/posix/bug-regex28.c
===================================================================
--- glibc-2.11.3.orig/posix/bug-regex28.c
+++ glibc-2.11.3/posix/bug-regex28.c
@@ -31,9 +31,9 @@ struct tests
 } tests[] = {
 #define EGREP RE_SYNTAX_EGREP
 #define EGREP_NL (RE_SYNTAX_EGREP | RE_DOT_NEWLINE) & ~RE_HAT_LISTS_NOT_NEWLINE
-  { "a.b", "a\nb", EGREP, -1 },
+  { "a.b", "a\nb", EGREP, 0 },
   { "a.b", "a\nb", EGREP_NL, 0 },
-  { "a[^x]b", "a\nb", EGREP, -1 },
+  { "a[^x]b", "a\nb", EGREP, 0 },
   { "a[^x]b", "a\nb", EGREP_NL, 0 },
   /* While \S and \W are internally handled as [^[:space:]] and [^[:alnum:]_],
      RE_HAT_LISTS_NOT_NEWLINE did not make any difference, so ensure
